"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }// src/index.ts
var _hashsum = require('hash-sum'); var _hashsum2 = _interopRequireDefault(_hashsum);
function loadingScript({ externalSrc, fileName = "app", crossorigin = false, crossoriginVal = "" } = {}) {
  return {
    name: "vite-plugin-loading-script",
    apply: "build",
    generateBundle(_, bundle) {
      const newScript = generateLoadingScript(bundle, externalSrc, crossorigin, crossoriginVal);
      this.emitFile({
        type: "asset",
        fileName: `${fileName}.${_hashsum2.default.call(void 0, newScript)}.js`,
        source: newScript
      });
    }
  };
}
var generateLoadingScript = (bundle, externalSource, crossorigin, crossoriginVal) => {
  let scriptCode = "(function () {let scriptTag = document.getElementsByTagName('script');scriptTag = scriptTag[scriptTag.length - 1];const parent = scriptTag.parentNode;";
  let counter = 0;
  for (const key in bundle) {
    const filename = externalSource ? externalSource + bundle[key].fileName : bundle[key].fileName;
    const varName = `file${counter}`;
    if (bundle[key].type === "chunk") {
      const chunk = bundle[key];
      if (chunk.isEntry) {
        scriptCode += `const ${varName} = document.createElement('script');`;
        scriptCode += `${varName}.setAttribute('src', '${filename}');`;
        scriptCode += `${varName}.setAttribute('type', 'module');`;
        if (crossorigin) {
          scriptCode += `${varName}.setAttribute('crossorigin', '${crossoriginVal}');`;
        }
      } else {
        scriptCode += `const ${varName} = document.createElement('link');`;
        scriptCode += `${varName}.setAttribute('href', '${filename}');`;
        scriptCode += `${varName}.setAttribute('rel', 'modulepreload');`;
      }
    } else if (bundle[key].type === "asset" && bundle[key].fileName.endsWith(".css")) {
      scriptCode += `const ${varName} = document.createElement('link');`;
      scriptCode += `${varName}.setAttribute('href', '${filename}');`;
      scriptCode += `${varName}.setAttribute('rel', 'stylesheet');`;
    } else {
      continue;
    }
    scriptCode += `parent.appendChild(${varName});`;
    counter++;
  }
  scriptCode += "})()";
  return scriptCode;
};


exports.loadingScript = loadingScript;
